{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: NIE ATAKUJACE SIE SKOCZKI                      *}
{*   Plik:                NIE.PAS                                        *}
{*   Autor:               Wojciech Rytter                                *}
{*************************************************************************}

{$M 65500,0,655360}
program NieAtakujaceSkoczki;
 const Maxn=100;
 var Max   :array [0..63,1..Maxn+2] of integer;
     Ile   :array [0..63,1..Maxn+2] of longint;
     Dziura:array [3..Maxn+2] of integer;
     n,m   :integer;
     l     :longint;

 procedure WczytajDane;
  var f:text;
      i:integer;
 begin
  assign(f,'NIE.IN');
  reset(f);
  read(f,n);
  for i:=3 to n+2 do read(f,Dziura[i]);
  close(f)
 end; {WczytajDane}

 function Waga(x:integer):integer;
  var w:integer;
 begin
  w:=0;  x:=x shr 3;
  while x>0 do begin
   if odd(x) then w:=w+1;
   x:=x div 2
  end;
  Waga:=w
 end; {Waga}

 function Bit(x,i:integer):boolean;
 begin
  Bit:=Odd(x shr i)
 end; {Bit}

 function Poprawna(x,k:integer):boolean;
 begin
  Poprawna:=not ((k=2) and (x<>0) or
                 (k=3) and (x and 7<>0) or
                 Bit(x,0) and Bit(x,5) or
                 Bit(x,3) and Bit(x,2))
 end; {Poprawna}

 function Edge(i,j,k:integer):boolean;
 begin
  Edge:=Poprawna(i,k-1) and Poprawna(j,k) and
        (i shr 3 and 7 = j and 7) and
        not ((Dziura[k]>0) and Bit(j,Dziura[k]+2)) and
        not (Bit(i,0) and Bit(j,4) or
        Bit(i,1) and Bit(j,3) or Bit(i,1) and Bit(j,5) or
        Bit(i,2) and Bit(j,4))
 end; {Edge}

 procedure Rozwiazanie;
  var i,j,k:integer;
 begin
  Max[0,2]:=0;  Ile[0,2]:=1;
  for k:=3 to n+2 do
   for j:=0 to 63 do begin
    m:=0;
    for i:=0 to 63 do
     if Edge(i,j,k) and (Max[i,k-1]+Waga(j)>M) then
      m:=Max[i,k-1]+Waga(j);
    l:=0;
    for i:=0 to 63 do
     if Edge(i,j,k) and (Max[i,k-1]+Waga(j)=m) then
      l:=l+Ile[i,k-1];
    Max[j,k]:=m;
    Ile[j,k]:=l
   end; {for j=1..63}

   {Obliczenie koncowego wyniku}

  m:=0;
  for i:=0 to 63 do
   if Max[i,n+2]>m then m:=Max[i,n+2];
  l:=0;
  for i:=0 to 63 do
   if Max[i,n+2]=m then l:=l+Ile[i,n+2]
 end; {Rozwiazanie}

 procedure ZapiszRozwiazanie;
  var f:text;
 begin
  assign(f,'NIE.OUT');
  rewrite(f);
  writeln(f,m,' ',l);
  close(f)
 end; {ZapiszRozwiazanie}

begin
 WczytajDane;
 Rozwiazanie;
 ZapiszRozwiazanie
end. {NieAtakujaceSkoczki}
